program FreeOTFE;

uses
  Forms,
  FreeOTFEfrmMain in 'FreeOTFEfrmMain.pas' {frmFreeOTFEMain},
  About_U in 'About_U.pas' {About_F},
  FreeOTFEConsts in 'FreeOTFEConsts.pas',
  FreeOTFEfrmVolProperties in 'FreeOTFEfrmVolProperties.pas' {frmFreeOTFEVolProperties},
  FreeOTFEfrmSelectOverwriteMethod in 'FreeOTFEfrmSelectOverwriteMethod.pas' {frmFreeOTFESelectOverwriteMethod},
  FreeOTFEfrmCDBDump in 'FreeOTFEfrmCDBDump.pas' {frmFreeOTFECDBDump},
  FreeOTFEfrmCDBBackupRestore in 'FreeOTFEfrmCDBBackupRestore.pas' {frmFreeOTFECDBBackupRestore},
  FreeOTFESettings in 'FreeOTFESettings.pas',
  FreeOTFEfrmOptions in 'FreeOTFEfrmOptions.pas' {frmOptions},
  Windows,
  SDUGeneral,
  FreeOTFEfrmGridReport in 'FreeOTFEfrmGridReport.pas' {frmGridReport},
  FreeOTFEfrmGridReport_Hash in 'FreeOTFEfrmGridReport_Hash.pas' {frmGridReport_Hash},
  FreeOTFEfrmGridReport_Cypher in 'FreeOTFEfrmGridReport_Cypher.pas' {frmGridReport_Cypher},
  FreeOTFEfmeOptions_Base in 'FreeOTFEfmeOptions_Base.pas' {fmeOptions_Base: TFrame},
  FreeOTFEfmeOptions_SystemTray in 'FreeOTFEfmeOptions_SystemTray.pas' {fmeOptions_SystemTray: TFrame},
  FreeOTFEfmeOptions_Hotkeys in 'FreeOTFEfmeOptions_Hotkeys.pas' {fmeOptions_Hotkeys: TFrame},
  FreeOTFEfmeOptions_General in 'FreeOTFEfmeOptions_General.pas' {fmeOptions_General: TFrame},
  FreeOTFEfmeOptions_AutoRun in 'FreeOTFEfmeOptions_Autorun.pas' {fmeOptions_Autorun: TFrame};

{$R *.RES}

var
  otherRunningAppWindow: THandle;
  CommandLineOnly: boolean;
  exitCode: integer;

begin
  GLOBAL_VAR_WM_FREEOTFE_RESTORE := RegisterWindowMessage('FREEOTFE_RESTORE');
  GLOBAL_VAR_WM_FREEOTFE_REFRESH := RegisterWindowMessage('FREEOTFE_REFRESH');

  Application.Initialize;
{$IFDEF VER185}
  // Vista fix for Delphi 2007 and later
  Application.MainFormOnTaskbar := TRUE;
{$ENDIF}
  Application.Title := 'FreeOTFE';

  Settings:= TFreeOTFESettings.Create();
  Settings.Load();

  Application.ShowMainForm := FALSE;
  // NOTE: The main form's Visible property is set to FALSE anyway - it *HAS*
  // to be, otherwise it'll be displayed; dispite the following two lines
  Application.CreateForm(TfrmFreeOTFEMain, frmFreeOTFEMain);
  frmFreeOTFEMain.visible := FALSE;
  Application.ShowMainForm := FALSE;

  CommandLineOnly := frmFreeOTFEMain.HandleCommandLineOpts(exitCode);


  //   if we were called with no command line arguments then
  //     if no running app was found then
  //       we continue to run the main app
  //     else
  //       we raise the previous application to the top
  //   else
  //     quit (ran with command line arguments)

  // if we were called with no command line arguments then
  if (not(CommandLineOnly)) then
    begin
    otherRunningAppWindow := SDUDetectExistingApp();
    // If no running app was found then
    if (
        (otherRunningAppWindow = 0) or
        Settings.OptAllowMultipleInstances
       ) then
      begin
      // We continue to run the main app
      frmFreeOTFEMain.visible := TRUE;
      Application.ShowMainForm := TRUE;
      frmFreeOTFEMain.InitApp();
      Application.Run;
      end
    else
      begin
      // Poke already running application
{$IFDEF VER185}
      SendMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_RESTORE, 0, 0);
{$ELSE}
      SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_RESTORE, 0, 0);
{$ENDIF}

// Alternativly:
//       SetForegroundWindow(otherRunningAppWindow);
      end;
    end
  else
    begin
    // Quit (ran with command line arguments)
    // (i.e. do nothing)
    Halt(exitCode);
    end;

  // Note: We *don't* free of the Settings object; the main form is still
  //       closing down at this stage, and this causes an exception.
  // Settings.Free();
  
end.
