unit FreeOTFEfmeOptions_Hotkeys;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FreeOTFEfmeOptions_Base, StdCtrls, ComCtrls;

type
  TfmeOptions_Hotkeys = class(TfmeOptions_Base)
    gbHotkeys: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    hkDismount: THotKey;
    ckHotkeyDismount: TCheckBox;
    ckHotkeyDismountEmerg: TCheckBox;
    hkDismountEmerg: THotKey;
    procedure FrameResize(Sender: TObject);
    procedure ckCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnableDisableControls(); override;
    procedure ReadSettings(); override;
    procedure WriteSettings(); override;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral,
  FreeOTFESettings;

procedure TfmeOptions_Hotkeys.FrameResize(Sender: TObject);
begin
  SDUCenterControl(gbHotkeys, ccHorizontal);
  SDUCenterControl(gbHotkeys, ccVertical, 25);
end;

procedure TfmeOptions_Hotkeys.ckCheckBoxClick(Sender: TObject);
begin
  inherited;
  EnableDisableControls();
end;

procedure TfmeOptions_Hotkeys.EnableDisableControls();
begin
  inherited;

  SDUEnableControl(hkDismount,      ckHotkeyDismount.checked);
  SDUEnableControl(hkDismountEmerg, ckHotkeyDismountEmerg.checked);
end;

procedure TfmeOptions_Hotkeys.ReadSettings();
begin
  // Hotkeys...
  ckHotkeyDismount.checked      := Settings.OptHKeyEnableDismount;
  hkDismount.HotKey             := Settings.OptHKeyKeyDismount;
  ckHotkeyDismountEmerg.checked := Settings.OptHKeyEnableDismountEmerg;
  hkDismountEmerg.HotKey        := Settings.OptHKeyKeyDismountEmerg;

end;

procedure TfmeOptions_Hotkeys.WriteSettings();
begin
  // Hotkeys...
  Settings.OptHKeyEnableDismount      := ckHotkeyDismount.checked;
  Settings.OptHKeyKeyDismount         := hkDismount.HotKey;
  Settings.OptHKeyEnableDismountEmerg := ckHotkeyDismountEmerg.checked;
  Settings.OptHKeyKeyDismountEmerg    := hkDismountEmerg.HotKey;

end;

END.

