unit FreeOTFEfmeOptions_SystemTray;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FreeOTFEfmeOptions_Base, StdCtrls;

type
  TfmeOptions_SystemTray = class(TfmeOptions_Base)
    gbSystemTrayIcon: TGroupBox;
    ckUseSystemTrayIcon: TCheckBox;
    ckMinToIcon: TCheckBox;
    ckCloseToIcon: TCheckBox;
    procedure FrameResize(Sender: TObject);
    procedure ckUseSystemTrayIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnableDisableControls(); override;
    procedure ReadSettings(); override;
    procedure WriteSettings(); override;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral,
  FreeOTFESettings;

procedure TfmeOptions_SystemTray.FrameResize(Sender: TObject);
begin
  SDUCenterControl(gbSystemTrayIcon, ccHorizontal);
  SDUCenterControl(gbSystemTrayIcon, ccVertical, 25);
end;

procedure TfmeOptions_SystemTray.ckUseSystemTrayIconClick(Sender: TObject);
begin
  inherited;
  EnableDisableControls();
end;

procedure TfmeOptions_SystemTray.EnableDisableControls();
begin
  inherited;

  SDUEnableControl(ckMinToIcon,   ckUseSystemTrayIcon.checked);
  SDUEnableControl(ckCloseToIcon, ckUseSystemTrayIcon.checked);
end;

procedure TfmeOptions_SystemTray.ReadSettings();
begin
  // System tray icon related...
  ckUseSystemTrayIcon.checked := Settings.OptSystemTrayIconDisplay;
  ckMinToIcon.checked         := Settings.OptSystemTrayIconMinTo;
  ckCloseToIcon.checked       := Settings.OptSystemTrayIconCloseTo;

end;

procedure TfmeOptions_SystemTray.WriteSettings();
begin
  // System tray icon related...
  Settings.OptSystemTrayIconDisplay := ckUseSystemTrayIcon.checked;
  Settings.OptSystemTrayIconMinTo   := ckMinToIcon.checked;
  Settings.OptSystemTrayIconCloseTo := ckCloseToIcon.checked;

end;

END.

