
#ifndef _SDUHexDump_H
#define _SDUHexDump_H   1

/* ========================================================================= */

/*
   Returns the *estimated* number of characters that a call to 
   SDUPrettyPrintHexwill require to prettyprint data.          
*/
unsigned int SDUPrettyPrintHexBufReq(
  const unsigned int bytes,
  const int width
);


/*
   Starting from offset "offset" (zero indexed) in "data", read "bytes" bytes
   and populate "output" with a null terminated pretty printed representation
   of data
   Each line in "output" will relate to "width" bytes from "data"
   data - Pointer to the data to be prettyprinted
   offset - Offset from the start of data to begin prettyprinting from
   bytes - Number of bytes from data to be prettyprinted
   output - Pointer to a buffer to receive the prettprinted output
            This must be at *least* SDUPrettyPrintHexBufReq bytes long
   outputLength - Length of output buffer
   Returns: 0 on success, nonzero on failure (e.g. output buffer too small)
*/
int SDUPrettyPrintHex(
  const unsigned char *data,
  const unsigned int offset,
  const unsigned int bytes,
  char* output,
  int outputLength,
  const int width
);

/* ========================================================================= */
/* ========================================================================= */

#endif




